<html>
<head>
<title>OgreTerrainQuadTreeNode.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_6cd0971983c3e0e5b0cb362e5db7fc9d.html">Terrain</a>      </li>
      <li class="navelem"><a class="el" href="dir_9b506231b651991d884bb23d993d7984.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreTerrainQuadTreeNode.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreTerrainQuadTreeNode_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Ogre_TerrainQuadTreeNode_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Ogre_TerrainQuadTreeNode_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreTerrainPrerequisites_8h.html">OgreTerrainPrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareIndexBuffer_8h.html">OgreHardwareIndexBuffer.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042     <span class="keyword">class </span>HardwareVertexBufferSharedPtr;
<a name="l00043"></a>00043     
<a name="l00085"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html">00085</a>     <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">TerrainAlloc</a>
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00097"></a>00097         <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>(<a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* parent, 
<a name="l00098"></a>00098             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> xoff, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> yoff, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> size, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> lod, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> depth, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> quadrant);
<a name="l00099"></a>00099         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>();
<a name="l00100"></a>00100 
<a name="l00102"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ac4f29eb4f9c0cbc296eac339a337c6f7">00102</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ac4f29eb4f9c0cbc296eac339a337c6f7" title="Get the horizontal offset into the main terrain data of this node.">getXOffset</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOffsetX; }
<a name="l00104"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a1deab7853bb57db2abb588f9298cba5e">00104</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a1deab7853bb57db2abb588f9298cba5e" title="Get the vertical offset into the main terrain data of this node.">getYOffset</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOffsetY; }
<a name="l00106"></a>00106         <span class="keywordtype">bool</span> isLeaf() <span class="keyword">const</span>;
<a name="l00108"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#aac7c8ab3539e51c3fbddcf1dff81b6d7">00108</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#aac7c8ab3539e51c3fbddcf1dff81b6d7" title="Get the base LOD level this node starts at (the highest LOD it handles)">getBaseLod</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mBaseLod; }
<a name="l00110"></a>00110         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> getLodCount() <span class="keyword">const</span>;
<a name="l00112"></a>00112         <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* getChild(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> child) <span class="keyword">const</span>;
<a name="l00114"></a>00114         <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* getParent() <span class="keyword">const</span>;
<a name="l00116"></a>00116         <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* getTerrain() <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00119"></a>00119         <span class="keywordtype">void</span> prepare();
<a name="l00121"></a>00121         <span class="keywordtype">void</span> prepare(<a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>&amp; stream);
<a name="l00123"></a>00123         <span class="keywordtype">void</span> load();
<a name="l00125"></a>00125         <span class="keywordtype">void</span> unload();
<a name="l00127"></a>00127         <span class="keywordtype">void</span> unprepare();
<a name="l00129"></a>00129         <span class="keywordtype">void</span> save(<a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>&amp; stream);
<a name="l00130"></a>00130 
<a name="l00131"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html">00131</a>         <span class="keyword">struct </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html">LodLevel</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">TerrainAlloc</a>
<a name="l00132"></a>00132         {
<a name="l00134"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#a83acad7c18103f157856e75e8744ddb8">00134</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#a83acad7c18103f157856e75e8744ddb8" title="Number of vertices rendered down one side (not including skirts)">batchSize</a>;
<a name="l00136"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#aacadac4ebd2adbe9d879b781faa90230">00136</a>             <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#aacadac4ebd2adbe9d879b781faa90230" title="Index data on the gpu.">gpuIndexData</a>;
<a name="l00138"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#a01670093b32d51d33f54146984fcd7ae">00138</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#a01670093b32d51d33f54146984fcd7ae" title="Maximum delta height between this and the next lower lod.">maxHeightDelta</a>;
<a name="l00140"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#a97945e1567da64b6b5ef7022e4f63da8">00140</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#a97945e1567da64b6b5ef7022e4f63da8" title="Temp calc area for max height delta.">calcMaxHeightDelta</a>;
<a name="l00142"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#ac82a3ddf378272493d9d82100c17597a">00142</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#ac82a3ddf378272493d9d82100c17597a" title="The most recently calculated transition distance.">lastTransitionDist</a>;
<a name="l00144"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#afd5d89ee1eaff154e44347c15af2fba3">00144</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#afd5d89ee1eaff154e44347c15af2fba3" title="The cFactor value used to calculate transitionDist.">lastCFactor</a>;
<a name="l00145"></a>00145 
<a name="l00146"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html#aeddb9d375b1579a98ea3d22610908cc2">00146</a>             <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html">LodLevel</a>() : gpuIndexData(0), maxHeightDelta(0), calcMaxHeightDelta(0),
<a name="l00147"></a>00147                 lastTransitionDist(0), lastCFactor(0) {}
<a name="l00148"></a>00148         };
<a name="l00149"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a475e46c4f95eafc0ec21489eeaafb1c5">00149</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;LodLevel*&gt;::type</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a475e46c4f95eafc0ec21489eeaafb1c5">LodLevelList</a>;
<a name="l00150"></a>00150 
<a name="l00156"></a>00156         <span class="keyword">const</span> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1LodLevel.html">LodLevel</a>* getLodLevel(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> lod);
<a name="l00157"></a>00157 
<a name="l00162"></a>00162         <span class="keywordtype">void</span> preDeltaCalculation(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect);
<a name="l00163"></a>00163 
<a name="l00165"></a>00165         <span class="keywordtype">void</span> notifyDelta(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> x, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> y, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> lod, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> delta);
<a name="l00166"></a>00166 
<a name="l00169"></a>00169         <span class="keywordtype">void</span> postDeltaCalculation(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect);
<a name="l00170"></a>00170 
<a name="l00174"></a>00174         <span class="keywordtype">void</span> finaliseDeltaValues(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect);
<a name="l00175"></a>00175 
<a name="l00182"></a>00182         <span class="keywordtype">void</span> assignVertexData(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> treeDepthStart, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> treeDepthEnd, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> resolution, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> sz);
<a name="l00183"></a>00183 
<a name="l00188"></a>00188         <span class="keywordtype">void</span> useAncestorVertexData(<a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* owner, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> treeDepthEnd, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> resolution);
<a name="l00189"></a>00189 
<a name="l00192"></a>00192         <span class="keywordtype">void</span> updateVertexData(<span class="keywordtype">bool</span> positions, <span class="keywordtype">bool</span> deltas, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect, <span class="keywordtype">bool</span> cpuData);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00202"></a>00202         <span class="keywordtype">void</span> mergeIntoBounds(<span class="keywordtype">long</span> x, <span class="keywordtype">long</span> y, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pos);
<a name="l00206"></a>00206         <span class="keywordtype">void</span> resetBounds(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect);
<a name="l00207"></a>00207         
<a name="l00212"></a>00212         <span class="keywordtype">bool</span> rectIntersectsNode(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect);
<a name="l00217"></a>00217         <span class="keywordtype">bool</span> rectContainsNode(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect);
<a name="l00222"></a>00222         <span class="keywordtype">bool</span> pointIntersectsNode(<span class="keywordtype">long</span> x, <span class="keywordtype">long</span> y);
<a name="l00223"></a>00223 
<a name="l00225"></a>00225         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getAABB() <span class="keyword">const</span>;
<a name="l00227"></a>00227         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius() <span class="keyword">const</span>;
<a name="l00229"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#aa7b2e9389c63c9616a00df63ff839e1c">00229</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#aa7b2e9389c63c9616a00df63ff839e1c" title="Get the local centre of this node, relative to parent terrain centre.">getLocalCentre</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLocalCentre; }
<a name="l00231"></a>00231         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMinHeight() <span class="keyword">const</span>;
<a name="l00233"></a>00233         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMaxHeight() <span class="keyword">const</span>;
<a name="l00234"></a>00234 
<a name="l00240"></a>00240         <span class="keywordtype">bool</span> calculateCurrentLod(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> cFactor);
<a name="l00241"></a>00241 
<a name="l00243"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#af7ad418d38e5ee30b84331651ed8f80e">00243</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#af7ad418d38e5ee30b84331651ed8f80e" title="Get the current LOD index (only valid after calculateCurrentLod)">getCurrentLod</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCurrentLod; }
<a name="l00245"></a>00245         <span class="keywordtype">bool</span> isRenderedAtCurrentLod() <span class="keyword">const</span>;
<a name="l00247"></a>00247         <span class="keywordtype">bool</span> isSelfOrChildRenderedAtCurrentLod() <span class="keyword">const</span>;
<a name="l00249"></a>00249         <span class="keywordtype">void</span> setCurrentLod(<span class="keywordtype">int</span> lod);
<a name="l00251"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a2e6813c2a631ca72f9cfb67e643c67e0">00251</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a2e6813c2a631ca72f9cfb67e643c67e0" title="Get the transition state between the current LOD and the next lower one (only valid after calculateCu...">getLodTransition</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLodTransition; }
<a name="l00253"></a>00253         <span class="keywordtype">void</span> setLodTransition(<span class="keywordtype">float</span> t);
<a name="l00254"></a>00254 
<a name="l00256"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ad2d323266710dcd2847eeb20af7ed734">00256</a>         <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ad2d323266710dcd2847eeb20af7ed734" title="Buffer binding used for holding positions.">POSITION_BUFFER</a>;
<a name="l00258"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a570b17be150e8de773197f801a6a2a2e">00258</a>         <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a570b17be150e8de773197f801a6a2a2e" title="Buffer binding used for holding delta values.">DELTA_BUFFER</a>;
<a name="l00259"></a>00259 
<a name="l00261"></a>00261         <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> *_getRenderable();
<a name="l00262"></a>00262     <span class="keyword">protected</span>:
<a name="l00263"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a2bfcacb272c82b9463d08351a9392f58">00263</a>         <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a2bfcacb272c82b9463d08351a9392f58">mTerrain</a>;
<a name="l00264"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a8aa424c4ecee60664385e946e2e739f0">00264</a>         <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a8aa424c4ecee60664385e946e2e739f0">mParent</a>;
<a name="l00265"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ac36b39f45c3c06658df823f5f47513a7">00265</a>         <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* mChildren[4];
<a name="l00266"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a13568bae644a58f7bda17dac14808cdc">00266</a>         <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a475e46c4f95eafc0ec21489eeaafb1c5">LodLevelList</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a13568bae644a58f7bda17dac14808cdc">mLodLevels</a>;
<a name="l00267"></a>00267 
<a name="l00268"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a2261090f671b4ab8456310dba8adc573">00268</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mOffsetX, <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a2261090f671b4ab8456310dba8adc573">mOffsetY</a>;
<a name="l00269"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#aa758c517214742b3b3c489cd3e6cdc77">00269</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mBoundaryX, <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#aa758c517214742b3b3c489cd3e6cdc77">mBoundaryY</a>;
<a name="l00271"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a8683463075875eaae70033a2b58524ab">00271</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a8683463075875eaae70033a2b58524ab" title="the number of vertices at the original terrain resolution this node encompasses">mSize</a>;
<a name="l00272"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a4824f29784d2b7d91184c33d90fdafb6">00272</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a4824f29784d2b7d91184c33d90fdafb6">mBaseLod</a>;
<a name="l00273"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a49a7dedeb4f8ef1515344f51894826ad">00273</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a49a7dedeb4f8ef1515344f51894826ad">mDepth</a>;
<a name="l00274"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a98975312f287bf573bb41306564d12f2">00274</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a98975312f287bf573bb41306564d12f2">mQuadrant</a>;
<a name="l00275"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#adb524712050d45c32402dd70793285c2">00275</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#adb524712050d45c32402dd70793285c2">mLocalCentre</a>; <span class="comment">// relative to terrain centre</span>
<a name="l00276"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a75d59573fa76b63c4192800730921143">00276</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a75d59573fa76b63c4192800730921143">mAABB</a>; <span class="comment">//relative to mLocalCentre</span>
<a name="l00277"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#adede028d5166828c7be7e5fe404e9fae">00277</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#adede028d5166828c7be7e5fe404e9fae">mBoundingRadius</a>; <span class="comment">//relative to mLocalCentre</span>
<a name="l00278"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a5ee1ac9952ea6b7fb8b024d0475a003c">00278</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a5ee1ac9952ea6b7fb8b024d0475a003c">mCurrentLod</a>; <span class="comment">// -1 = none (do not render)</span>
<a name="l00279"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a58275eb91d1c3b75fc26436d1e4c8a8c">00279</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a58275eb91d1c3b75fc26436d1e4c8a8c">mMaterialLodIndex</a>;
<a name="l00280"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#aa203ffdfe0530da9a5bea6d08c9ecbbd">00280</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#aa203ffdfe0530da9a5bea6d08c9ecbbd">mLodTransition</a>; <span class="comment">// 0-1 transition to lower LOD</span>
<a name="l00282"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a301fec692f7abcf07fa8bda970c0578a">00282</a> <span class="comment"></span>        <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a301fec692f7abcf07fa8bda970c0578a" title="The child with the largest height delta.">mChildWithMaxHeightDelta</a>;
<a name="l00283"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a8b96f34a1e15ca520df2444db6a9ecaa">00283</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a8b96f34a1e15ca520df2444db6a9ecaa">mSelfOrChildRendered</a>;
<a name="l00284"></a>00284 
<a name="l00285"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html">00285</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html">VertexDataRecord</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">TerrainAlloc</a>
<a name="l00286"></a>00286         {
<a name="l00287"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#ad61a19dafe4d316716c2018e261130ca">00287</a>             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#ad61a19dafe4d316716c2018e261130ca">cpuVertexData</a>;
<a name="l00288"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#a9121aa5c121589b3fa3aea55308f0320">00288</a>             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#a9121aa5c121589b3fa3aea55308f0320">gpuVertexData</a>;
<a name="l00290"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#a7bc1b6f17218e614d07d38780494808f">00290</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#a7bc1b6f17218e614d07d38780494808f" title="resolution of the data compared to the base terrain data (NOT number of vertices!)">resolution</a>;
<a name="l00292"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#af29723ef0f2d95e9d10e4388e51cf944">00292</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#af29723ef0f2d95e9d10e4388e51cf944" title="size of the data along one edge">size</a>;
<a name="l00294"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#acd33dd8f3b58379599d74e188402327f">00294</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#acd33dd8f3b58379599d74e188402327f" title="Number of quadtree levels (including this one) this data applies to.">treeLevels</a>;
<a name="l00296"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#aa4c7204a5bd68aae6a3dbc92afce0499">00296</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#aa4c7204a5bd68aae6a3dbc92afce0499" title="Number of rows and columns of skirts.">numSkirtRowsCols</a>;
<a name="l00298"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#af238e675c6ca2014efb8b1ed7887767f">00298</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#af238e675c6ca2014efb8b1ed7887767f" title="The number of rows / cols to skip in between skirts.">skirtRowColSkip</a>;
<a name="l00300"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#ac3e4f3a42c37397d8b5da61b342008c4">00300</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#ac3e4f3a42c37397d8b5da61b342008c4" title="Is the GPU vertex data out of date?">gpuVertexDataDirty</a>;
<a name="l00301"></a>00301 
<a name="l00302"></a><a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html#a4a7dfa663f1b0ae3c3569bfcdbb714e1">00302</a>             <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html">VertexDataRecord</a>(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> res, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> sz, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> lvls) 
<a name="l00303"></a>00303                 : cpuVertexData(0), gpuVertexData(0), resolution(res), size(sz),
<a name="l00304"></a>00304                 treeLevels(lvls), gpuVertexDataDirty(false) {}
<a name="l00305"></a>00305         };
<a name="l00306"></a>00306         
<a name="l00307"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a2d5345464d1721cc117a69e6b03ea353">00307</a>         <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a2d5345464d1721cc117a69e6b03ea353">mNodeWithVertexData</a>;
<a name="l00308"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a4212bf24207e2c5afc8327155e28f188">00308</a>         <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html">VertexDataRecord</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a4212bf24207e2c5afc8327155e28f188">mVertexDataRecord</a>;
<a name="l00309"></a>00309 
<a name="l00329"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html">00329</a>         <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html" title="MovableObject implementation to provide the hook to the scene.">Movable</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>
<a name="l00330"></a>00330         {
<a name="l00331"></a>00331         <span class="keyword">protected</span>:
<a name="l00332"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html#a99c7787bfb93d3a324bb2294046b3b62">00332</a>             <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html#a99c7787bfb93d3a324bb2294046b3b62">mParent</a>;
<a name="l00333"></a>00333         <span class="keyword">public</span>:
<a name="l00334"></a>00334             <a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html" title="MovableObject implementation to provide the hook to the scene.">Movable</a>(<a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* parent);
<a name="l00335"></a>00335             ~<a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html" title="MovableObject implementation to provide the hook to the scene.">Movable</a>();
<a name="l00336"></a>00336             
<a name="l00337"></a>00337             <span class="comment">// necessary overrides</span>
<a name="l00338"></a>00338             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00339"></a>00339             <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00340"></a>00340             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00341"></a>00341             <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00342"></a>00342             <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor,  <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>);
<a name="l00343"></a>00343             <span class="keywordtype">bool</span> isVisible(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00344"></a>00344             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getVisibilityFlags(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00345"></a>00345             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getQueryFlags(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00346"></a>00346             <span class="keywordtype">bool</span> getCastShadows(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348         };
<a name="l00349"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a53f019b3e9a2e55083fa0da83656ff42">00349</a>         <a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html" title="MovableObject implementation to provide the hook to the scene.">Movable</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a53f019b3e9a2e55083fa0da83656ff42">mMovable</a>;
<a name="l00350"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#a580bc16a3fc18eb382fed53c6a31c365">00350</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html" title="MovableObject implementation to provide the hook to the scene.">Movable</a>;
<a name="l00351"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ab8aa4a53fe2ccfd98c14edc0b039647c">00351</a>         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ab8aa4a53fe2ccfd98c14edc0b039647c">mLocalNode</a>;
<a name="l00352"></a>00352 
<a name="l00354"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Rend.html">00354</a>         <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Rend.html" title="Hook to the render queue.">Rend</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">TerrainAlloc</a>
<a name="l00355"></a>00355         {
<a name="l00356"></a>00356         <span class="keyword">protected</span>:
<a name="l00357"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Rend.html#a021b04bdb23717caf74f0916d8828cab">00357</a>             <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Rend.html#a021b04bdb23717caf74f0916d8828cab">mParent</a>;
<a name="l00358"></a>00358         <span class="keyword">public</span>:
<a name="l00359"></a>00359             <a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Rend.html" title="Hook to the render queue.">Rend</a>(<a class="code" href="classOgre_1_1TerrainQuadTreeNode.html" title="A node in a quad tree used to store a patch of terrain.">TerrainQuadTreeNode</a>* parent);
<a name="l00360"></a>00360             ~<a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Rend.html" title="Hook to the render queue.">Rend</a>();
<a name="l00361"></a>00361 
<a name="l00362"></a>00362             <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00363"></a>00363             <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getTechnique(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00364"></a>00364             <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00365"></a>00365             <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00366"></a>00366             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span>;
<a name="l00367"></a>00367             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00368"></a>00368             <span class="keywordtype">bool</span> getCastsShadows(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00369"></a>00369 
<a name="l00370"></a>00370         };
<a name="l00371"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ae9d0bfee226c6d64db14d75738242183">00371</a>         <a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Rend.html" title="Hook to the render queue.">Rend</a>* <a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ae9d0bfee226c6d64db14d75738242183">mRend</a>;
<a name="l00372"></a><a class="code" href="classOgre_1_1TerrainQuadTreeNode.html#ad27630b21ec9f09d2b5f23dffd484aa7">00372</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1TerrainQuadTreeNode_1_1Rend.html" title="Hook to the render queue.">Rend</a>;
<a name="l00373"></a>00373 
<a name="l00374"></a>00374         <span class="comment">// actual implementation of MovableObject methods</span>
<a name="l00375"></a>00375         <span class="keywordtype">void</span> updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00376"></a>00376         <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor,  <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>);
<a name="l00377"></a>00377         <span class="comment">// actual implementations of Renderable methods</span>
<a name="l00378"></a>00378         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00379"></a>00379         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getTechnique(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00380"></a>00380         <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00381"></a>00381         <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00382"></a>00382         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span>;
<a name="l00383"></a>00383         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00384"></a>00384         <span class="keywordtype">bool</span> getCastsShadows(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387         <span class="keyword">const</span> <a class="code" href="structOgre_1_1TerrainQuadTreeNode_1_1VertexDataRecord.html">VertexDataRecord</a>* getVertexDataRecord() <span class="keyword">const</span>;
<a name="l00388"></a>00388         <span class="keywordtype">void</span> createCpuVertexData();
<a name="l00389"></a>00389         <span class="comment">/* Update the vertex buffers - the rect in question is relative to the whole terrain, </span>
<a name="l00390"></a>00390 <span class="comment">            not the local vertex data (which may use a subset)</span>
<a name="l00391"></a>00391 <span class="comment">        */</span>
<a name="l00392"></a>00392         <span class="keywordtype">void</span> updateVertexBuffer(<a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; posbuf, <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; deltabuf, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">Rect</a>&amp; rect);
<a name="l00393"></a>00393         <span class="keywordtype">void</span> destroyCpuVertexData();
<a name="l00394"></a>00394 
<a name="l00395"></a>00395         <span class="keywordtype">void</span> createGpuVertexData();
<a name="l00396"></a>00396         <span class="keywordtype">void</span> destroyGpuVertexData();
<a name="l00397"></a>00397         <span class="keywordtype">void</span> updateGpuVertexData();
<a name="l00398"></a>00398         <span class="keywordtype">void</span> createGpuIndexData();
<a name="l00399"></a>00399         <span class="keywordtype">void</span> destroyGpuIndexData();
<a name="l00400"></a>00400 
<a name="l00401"></a>00401         <span class="keywordtype">void</span> populateIndexData(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> batchSize, <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* destData);
<a name="l00402"></a>00402         <span class="keywordtype">void</span> writePosVertex(<span class="keywordtype">bool</span> compress, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> x, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> y, <span class="keywordtype">float</span> height, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pos, <span class="keywordtype">float</span> uvScale, <span class="keywordtype">float</span>** ppPos);
<a name="l00403"></a>00403         <span class="keywordtype">void</span> writeDeltaVertex(<span class="keywordtype">bool</span> compress, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> x, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> y, <span class="keywordtype">float</span> delta, <span class="keywordtype">float</span> deltaThresh, <span class="keywordtype">float</span>** ppDelta);
<a name="l00404"></a>00404         
<a name="l00405"></a>00405         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> calcSkirtVertexIndex(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mainIndex, <span class="keywordtype">bool</span> isCol);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407     };
<a name="l00408"></a>00408 
<a name="l00411"></a>00411 }
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
